import { Stack, Theme, Typography, useTheme, withTheme } from "@mui/material";
import React from "react";
import { Bus } from "./Bus";
import { range } from "@/utils/Range";

export interface BusesListProps {
  physical: number;
  virtual: number;
  width: number;
}
export interface BusesListState {
}

export class BusesList extends React.Component<BusesListProps, BusesListState> {
  constructor(props: BusesListProps) {
    super(props);
  }
  mapCallback(
    ...args: Parameters<
      Parameters<Parameters<typeof Array<number>>["map"]>["0"]
    >
  ) {
    const [busId] = args;
    const isPhysical = busId < this.props.physical;
    return (
      <React.Fragment
        key={`${isPhysical ? "A" : "B"}${
          isPhysical ? busId + 1 : busId - this.props.physical + 1
        }`}
      >
        <Typography variant="caption">{`${isPhysical ? "A" : "B"}${
          isPhysical ? busId + 1 : busId - this.props.physical + 1
        }`}</Typography>
        <Bus onChange={console.log} />
      </React.Fragment>
    );
  }
  render(): React.ReactNode {
    if (this.props.width > 600) {
      return (
        <Stack direction={"row"} spacing={this.props.width > 1200 ? 4 : 2}>
          <Stack sx={{ width: "50%" }}>
            {range(this.props.physical).map(this.mapCallback.bind(this))}
          </Stack>
          <Stack sx={{ width: "50%" }}>
            {range(this.props.virtual, this.props.physical).map(
              this.mapCallback.bind(this)
            )}
          </Stack>
        </Stack>
      );
    }
    return (
      <Stack>
        {range(this.props.physical + this.props.virtual).map(
          this.mapCallback.bind(this)
        )}
      </Stack>
    );
  }
}
